Bug 975163 - pulp-admin puppet install and update don't have a --force flag
pulp-admin puppet install and update don't have a --force flag
Status: CLOSED UPSTREAM
Product: Pulp
Classification: Community
Component: puppet-support (Show other bugs)
2.2 Beta
Unspecified Unspecified
low Severity unspecified
: ---
: ---
Assigned To: pulp-bugs
Preethi Thomas
: FutureFeature, Triaged
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2013-06-17 14:12 EDT by Jeremy Cline
Modified: 2015-02-28 18:40 EST (History)
2 users (show)

See Also:
Fixed In Version:
Doc Type: Enhancement
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2015-02-18 20:11:17 EST
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)


External Trackers
Tracker ID Priority Status Summary Last Updated
Pulp Redmine 196 None None None Never

  None (edit)
Description Jeremy Cline 2013-06-17 14:12:18 EDT
Description of problem: puppet module install and upgrade have a --force flag which can be used to force a reinstallation of already installed modules. When trying to install or update a module in pulp, there is no such option and the operation does not succeed.


Version-Release number of selected component (if applicable): pulp-puppet-admin-extensions-2.2.0-0.3.beta.fc18.noarch


How reproducible: Always


Steps to Reproduce:
1. pulp-admin puppet repo create --repo-id=puppet-repo --feed=http://forge.puppetlabs.com/ --queries=puppetlabs
2. pulp-admin puppet repo sync run --repo-id=puppet-repo
3. pulp-admin puppet consumer bind --consumer-id=puppet-install --repo-id=puppet-repo
4. pulp-admin puppet consumer install run --consumer-id=puppet-install --content-unit=puppetlabs/stdlib
5. pulp-admin puppet consumer install run --consumer-id=puppet-install --content-unit=puppetlabs/stdlib OR pulp-admin puppet consumer update run --consumer-id=puppet-install --content-unit=puppetlabs/stdlib

Actual results:
Operations:  unit_update
Resources:   puppet-install (consumer)
State:       Successful
Start Time:  2013-06-17T16:06:20Z
Finish Time: 2013-06-17T16:06:21Z
Result:      
  Details:     
    Puppet Module: 
      Details:   
        Errors:    
          Puppetlabs/stdlib: 
            Error:             
              Multiline: Could not upgrade module 'puppetlabs-stdlib' (v4.1.0 ->
                         latest: v4.1.0)   The installed version is already the
                         latest version     Use `puppet module install --force`
                         to re-install this module
              Oneline:   Could not upgrade 'puppetlabs-stdlib'; module is not
                         installed
            Installed Version: v4.1.0
            Module Name:       puppetlabs-stdlib
            Requested Version: latest
            Result:            noop
        Successes: 
      Succeeded: True
  Num Changes: 0
  Reboot:      
    Details:   
    Scheduled: False
  Succeeded:   True
Task Id:     3c17dbde-b54e-40be-9377-892ff3c45db7

however there is no --force flag for pulp-admin puppet consumer install run


Expected results: 
A --force flag that allows reinstallation of a module like puppet has:
[jcline@jcline ~]$ puppet module install puppetlabs-stdlib
Notice: Preparing to install into /home/jcline/.puppet/modules ...
Error: Could not install module 'puppetlabs-stdlib' (latest)
  Module 'puppetlabs-stdlib' (v4.1.0) is already installed
    Use `puppet module upgrade` to install a different version
    Use `puppet module install --force` to re-install only this module
[jcline@jcline ~]$ puppet module install puppetlabs-stdlib --force
Notice: Preparing to install into /home/jcline/.puppet/modules ...
Notice: Downloading from https://forge.puppetlabs.com ...
Notice: Installing -- do not interrupt ...
/home/jcline/.puppet/modules
└── puppetlabs-stdlib (v4.1.0)

Additional info:
Comment 1 Michael Hrivnak 2013-06-21 11:04:50 EDT
We don't have this for rpm installs either. I think this is fairly low on the priority list, so I'm kicking it down the road a bit.
Comment 3 Chris Duryee 2014-11-11 17:04:21 EST
This is still outstanding as of 2.4.3

$ pulp-admin puppet consumer install run
Command: run
Description: triggers an immediate content unit install on the consumer

Available Arguments:

  --bg               - if specified, the client process will end immediately
                       (the task will continue to run on the server)
  --consumer-id      - (required) unique identifier; only alphanumeric, ., -,
                       and _ allowed
  --content-unit, -u - module name with optional version as
                       "author/title[/version]"
  --whole-repo, -w   - install all modules from the repository with this ID
The following options are required but were not specified:
  --consumer-id
Comment 4 Brian Bouterse 2015-02-18 20:11:17 EST
Moved to https://pulp.plan.io/issues/196

Note You need to log in before you can comment on or make changes to this bug.